unit uFenster;
(* ******************************************************************** *)
(* K L A S S E : --                                                     *)
(* -------------------------------------------------------------------- *)
(* Version     : --                                                     *)
(* Autor       : S. Spolwig, OSZ Handel I                               *)
(* Beschreibung: Das Fenster aggregiert nur GUI-Komponenten zum ben.   *)
(*               der Delphi-Umgebung.                                   *)
(*               Die dargestellte Ampel ist kein Objekt (Exemplar einer *)
(*               Ampel-Klasse !!! )                                     *)
(* Compiler    : Delphi 3.0                                             *)
(* Aenderungen : V. 1.0   - 15-JAN-99                                   *)
(* ******************************************************************** *)


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFensterFrm = class(TForm)
    HaltBtn     : TButton;
    Panel1      : TPanel;
    RoteLampe   : TShape;
    GelbeLampe  : TShape;
    GrueneLampe : TShape;
    FahrenBtn   : TButton;
    Abschalten  : TButton;
    Memo1       : TMemo;
    Shape4      : TShape;
    BlinkenBtn: TButton;
    AchtungBtn  : TButton;
    HinweisPnl  : TPanel;
    AutomatikCBox: TCheckBox;

    procedure HaltBtnClick(Sender: TObject);
    procedure FahrenBtnClick(Sender: TObject);
    procedure AchtungBtnClick(Sender: TObject);
    procedure AbschaltenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BlinkenBtnClick(Sender: TObject);
    procedure AutomatikCBoxClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FensterFrm: TFensterFrm;

implementation

{$R *.DFM}

procedure Pause(zeit : longint);      // muss noch woanders hin -> uZeit
(* --------------------------------------------------------------- *)
(*  Aufgabe: Programm fuer zeit unterbrechen                       *)
(*  vorher : -                                                     *)
(*  nachher: Programm laueft weiter                                *)
(* --------------------------------------------------------------- *)
var
   zeit1 : longint;
begin
   zeit1:= GetTickCount;
   repeat
      Application.ProcessMessages
   until (GetTickCount - zeit1 > zeit);
end;

procedure TFensterFrm.HaltBtnClick(Sender: TObject);
begin
   RoteLampe.Brush.Color := clRed;
   GrueneLampe.Brush.Color := clBlack;
   GelbeLampe.Brush.Color := clBlack;
end;


procedure TFensterFrm.FahrenBtnClick(Sender: TObject);
begin
  RoteLampe.Brush.Color := clBlack;
  GrueneLampe.Brush.Color := clGreen;
  GelbeLampe.Brush.Color := clBlack;
end;


procedure TFensterFrm.AchtungBtnClick(Sender: TObject);
begin
  RoteLampe.Brush.Color := clBlack;
  GrueneLampe.Brush.Color := clBlack;
  GelbeLampe.Brush.Color := clYellow;
end;

procedure TFensterFrm.AbschaltenClick(Sender: TObject);
begin
  RoteLampe.Brush.Color   := clBlack;
  GrueneLampe.Brush.Color := clBlack;
  GelbeLampe.Brush.Color  := clBlack;
end;

procedure TFensterFrm.FormCreate(Sender: TObject);
begin
 HinweisPnl.CAption := 'Dies ist keine Ampel !';
 RoteLampe.Brush.Color  := clBlack;
 GelbeLampe.Brush.Color := clBlack;
 GrueneLampe.Brush.Color:= clBlack;
end;

procedure TFensterFrm.BlinkenBtnClick(Sender: TObject);
var i : integer;
begin
  GelbeLampe.Brush.Color := clYellow;
  for i := 1 to 10 do
  begin
    GelbeLampe.Visible := true;
    pause(200);
    GelbeLampe.Visible := false;
    pause(200);
  end;
   GelbeLampe.Visible := true;
end;



procedure TFensterFrm.AutomatikCBoxClick(Sender: TObject);
begin
  repeat
    HaltBtnClick(Sender);
    pause(500 );
    AchtungBtnClick(sender);
    pause(500 );
    FahrenBtnClick(sender);
    pause(500 );
  until AutomatikCbox.Checked = false;
end;

end.
