unit uFenster;
(* ******************************************************************** *)
(* K L A S S E :  FensterFrm                                            *)
(* -------------------------------------------------------------------- *)
(* Version     :  2.0  - Blinken mit versch. Schleifen u. Bedingungen   *)
(* Autor       :                                                        *)
(*                                                                      *)
(* Aufgabe     : Fenster uebernimmt die Ein-/Ausgabe und steuert die    *)
(*               Funktionen der Ampelsimulation ber ein GUI.           *)
(* Compiler    : DELPHI 5.0                                             *)
(* ******************************************************************** *)

interface
// ====================================================================

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uZeit;

type
  TFensterFrm = class(TForm)
    EndeBtn   : TButton;
    RotBtn    : TButton;
    GruenBtn  : TButton;
    GelbBtn   : TButton;
    RotPnl    : TPanel;
    GelbPnl   : TPanel;
    GruenPnl  : TPanel;
    Panel1    : TPanel;
    Panel3    : TPanel;
    BlinkBtn  : TButton;
    StopBtn   : TButton;
    MeldePnl  : TPanel;

    procedure EndeBtnClick(Sender: TObject);
    procedure RotBtnClick(Sender: TObject);
    procedure GruenBtnClick(Sender: TObject);
    procedure GelbBtnClick(Sender: TObject);
    procedure BlinkBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);

   private
    procedure Blinken1;
    procedure Blinken2;
    procedure Blinken3;

   public
  end;


var
  FensterFrm: TFensterFrm;
  BlinkenAus: boolean;

implementation
// ====================================================================
{$R *.DFM}

procedure TFensterFrm.EndeBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  FensterFrm.Close;
end;


procedure TFensterFrm.RotBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  RotPnl.Color   := clRED;
  GruenPnl.Color := clBlack;
  GelbPnl.Color  := clBlack;
end;

procedure TFensterFrm.GruenBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  GruenPnl.Color := clGreen;
  RotPnl.Color   := clBlack;
  GelbPnl.Color  := clBlack;
end;

procedure TFensterFrm.GelbBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  GelbPnl.Color  := clYellow;
  RotPnl.Color   := clBlack;
  GruenPnl.Color := clBlack;
end;


procedure TFensterFrm.BlinkBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
 // BlinkenAus := false;
  Blinken3;
end;

procedure TFensterFrm.StopBtnClick(Sender: TObject);
// --------------------------------------------------------------------
begin
  BlinkenAus := true;
end;

// ====================== private Methoden =============================


procedure TFensterFrm.Blinken1;
// --------------------------------------------------------------------
var zaehler : integer;

begin
  for zaehler := 1 to 10 do
  begin
    GelbPnl.Color  := clYellow;
    Zeit.SetPause(500);
    GelbPnl.Color  := clBlack;
    Zeit.SetPause(500);
  end;
end;


procedure TFensterFrm.Blinken2;
// --------------------------------------------------------------------
begin
  while BlinkenAus = false do
  begin
    GelbPnl.Color  := clYellow;
    Zeit.SetPause(500);
    GelbPnl.Color  := clBlack;
    Zeit.SetPause(500);
  end;
end;


procedure TFensterFrm.Blinken3;
// --------------------------------------------------------------------
var zaehler : integer;
begin
  zaehler := 0;
  repeat
    GelbPnl.Color  := clYellow;
    Zeit.SetPause(200);
    GelbPnl.Color  := clBlack;
    Zeit.SetPause(200);

    zaehler := zaehler + 1;

    if zaehler = 10
    then MeldePnl.Caption := 'Notabschaltung in 5 Sek. !!'
    {
    else
      if zaehler = 15
      then
        begin
           MeldePnl.Caption := 'Notabschaltung!!!!';
           BlinkenAus := true;
        end
      else MeldePnl.Caption := inttostr(zaehler);
}
 until BlinkenAus = true;
end;

END.  // ============= Unit ===========================================
