unit uFenster;
(* ******************************************************************** *)
(* K L A S S E :  Fenster - Uebung Ampel automatisch                    *)
(* -------------------------------------------------------------------- *)
(* Version     : 3.0  - Automatik                                       *)
(* Autor       :                                                        *)
(*                                                                      *)
(* Aufgabe     : Fenster uebernimmt die Ein-/Ausgabe und steuert die    *)
(*               Ampel- Funktionen ber ein GUI.                        *)
(* Compiler    : DELPHI 3.0                                             *)
(* Aenderung   : V. 1.0 - 28-JAN-99                                     *)
(* ******************************************************************** *)

interface
(* ==================================================================== *)

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,
  uZeit; // Pause

type
  TFensterFrm = class(TForm)
    EndeBtn   : TButton;
    RotBtn    : TButton;
    GruenBtn  : TButton;
    GelbBtn   : TButton;
    RotPnl    : TPanel;
    GelbPnl   : TPanel;
    GruenPnl  : TPanel;
    Panel1    : TPanel;
    Panel3    : TPanel;
    AutoBtn   : TButton;
    ManuellBtn: TButton;

    procedure EndeBtnClick(Sender: TObject);
    procedure RotBtnClick(Sender: TObject);
    procedure GruenBtnClick(Sender: TObject);
    procedure GelbBtnClick(Sender: TObject);
    procedure AutoBtnClick(Sender: TObject);
    procedure ManuellBtnClick(Sender: TObject);

   private
    procedure Umschalten;
   public
  end;


var
  FensterFrm    : TFensterFrm;
  AutomatikAus  : boolean;

implementation
(* ==================================================================== *)
{$R *.DFM}

procedure TFensterFrm.EndeBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  FensterFrm.Close;
end;

procedure TFensterFrm.RotBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
 RotPnl.Color   := clRED;
 GruenPnl.Color := clBlack;
 GelbPnl.Color  := clBlack;
end;

procedure TFensterFrm.GruenBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
   GruenPnl.Color := clGreen;
   RotPnl.Color   := clBlack;
   GelbPnl.Color  := clBlack;
end;

procedure TFensterFrm.GelbBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  GelbPnl.Color  := clYellow;
  RotPnl.Color   := clBlack;
  GruenPnl.Color := clBlack;
end;


procedure TFensterFrm.AutoBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  AutomatikAus := false;
//  Umschalten;   // 2. Schritt !!

//   while NOT AutomatikAus = false do
//   begin
  repeat
    RotBtnClick(Sender);
    Zeit.Setpause(500 );
    GelbBtnClick(sender);
    Zeit.Setpause(500 );
    GruenBtnClick(sender);
    Zeit.Setpause(500 );
   //end;
  until AutomatikAus = true;
end;


procedure TFensterFrm.ManuellBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  AutomatikAus := true;
 // Umschalten;    // 2. Schritt
end;


procedure TFensterFrm.Umschalten;
(* -------------------------------------------------------------------- *)
begin
  if AutomatikAus = true
  then
    begin
      GelbBtn.Enabled  := true;
      RotBtn.Enabled   := true;
      GruenBtn.Enabled := true
    end
  else
    begin
      GelbBtn.Enabled  := false;
      RotBtn.Enabled   := false;
      GruenBtn.Enabled := false;
    end;
end;

END.
